import React, { Component } from 'react';
import style from './index.less';
import info from './../img/info.png';
import info1 from './../img/info1.png';
import drugIcon from './../img/drug.png';
import more from '@common/images/addItem1.png';
import $ from "jquery";

class DrugTreat extends Component {
    constructor(props) {
        super(props);
        this.state = {
            currentImg: -1,
        }
        this.handleSelect = this.handleSelect.bind(this);
        this.setOtherRecommend = this.setOtherRecommend.bind(this);
        this.setDrugInfo = this.setDrugInfo.bind(this);
        this.showTreatDesc = this.showTreatDesc.bind(this);
        this.handleMouseLeaveImg = this.handleMouseLeaveImg.bind(this)
    }

    handleSelect(index,ii) {
        const { selectDrug } = this.props;
        selectDrug && selectDrug(index,ii);
    }
    handleMouseEnterImg(ii, index) {
        this.setState({
            currentIndex: index,
            currentImg: ii
        })
    }
    handleMouseLeaveImg() {
        this.setState({
            currentIndex: -1,
        })
    }
    setOtherRecommend(item, index) {
        this.showTreatDesc();
        const { setOtherRecommend } = this.props;
        setOtherRecommend && setOtherRecommend(item, index);
    }
    setDrugInfo(item) {
        const { setDrugInfo } = this.props;
        setDrugInfo && setDrugInfo(item);
    }
    //搜索药品说明书（查看数据用）
    handleInputDrug(e) {
        this.setState({
            drugId: e.target.value
         })
    }
    //搜索药品说明书（查看数据用）
    searchDrug() {
        const { showDrugInfo } = this.props
        this.setDrugInfo({id: this.state.drugId})
        showDrugInfo && showDrugInfo();

    }
    showTreatDesc() {
        $('#treatDescBox').css({'display': 'block'});
        $('#treatWrapper').animate({'margin-left': '-470px'}, 300);
        $('#treatDescBox').animate({'width': '260px'}, 500);
        
    }
    


    render(){
        const { treatment,showDrugInfo } = this.props
        const { currentImg, currentIndex } = this.state
        return(
            treatment && treatment.length > 0 && <div className={style['drug-box']}>
                <h3 className={style['drug-title']}><img className={style['drug-icon']} src={drugIcon}/> 常用药物治疗</h3>
                {/* 查看药物说明书 */}
                <div> <input onInput={this.handleInputDrug.bind(this)} style={{border:'1px solid #000'}} type="text"/><button onClick = {this.searchDrug.bind(this)}>搜索药品说明</button></div>
                {treatment.map((item, index) => {
                    return(<div className={style['drug-content']}>
                        <div  className={style['drug-name-box']}>
                            <span>{index + 1 + '. ' }{item.bigdrugsName}<span>({item.subdrugsName})</span>:&nbsp;</span>
                            {item.medicitionsList.map((it, ii) => {
                                return ((it.isShow == 1 || it.selected) && <span >
                                        {ii === 0 ? '' : ', '}
                                        <span className={style['drug-name']}  
                                            // onDoubleClick={() =>{this.setDrugInfo(it);showDrugInfo();}}  //药品说明双击显示（现在为点击图标显示）
                                            onClick={()=>{it.forbidden === '2' ? '' : this.handleSelect(index,ii)}} 
                                            style={it.forbidden === '2' ? {opacity: '0.3', filter:'alpha(opacity=30)',filter:'progid:DXImageTransform.Microsoft.Alpha(opacity=30)'} : it.selected ? {color: '#3B9ED0', borderBottom: '1px solid #3B9ED0'}:''}
                                            >
                                            {it.medicitionName}
                                        </span>
                                        {<img className={style['info-img']}    
                                              src={currentIndex === index ? (ii === currentImg ? info1 : info) : info} 
                                              onMouseEnter={this.handleMouseEnterImg.bind(this, ii, index)}
                                              onMouseLeave = {this.handleMouseLeaveImg}
                                              onClick={() =>{this.setDrugInfo(it);showDrugInfo();}}/>}
                                        {it.forbidden === '1' ? <span className={style['info-flag']} style={{opacity: '0.3',border: '1px solid #F4C051', background: '#F4C051',marginLeft: '5px'}}>慎用</span>: it.forbidden === '2' ? <span className={style['info-flag']} style={{opacity: '0.3',filter:'alpha(opacity=30)',filter:'progid:DXImageTransform.Microsoft.Alpha(opacity=30)',border: '1px solid #000',marginLeft: '5px'}}>禁用</span> : ''}, 使用率{it.rate}
                                        
                                    </span>)
                            })}

                        </div>
                        {<div className={style['drug-more']} onClick={() =>this.setOtherRecommend(item, index)} ><img className={style['info-img']} src={more} />更多同类药</div> }
                        
                    </div>)
                })}
            </div>
        )
    }
}

export default DrugTreat;